package domowe.r4.pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Map;
import java.util.Scanner;
import java.util.function.Function;
import java.util.stream.Collectors;

public class PoliczWszystkieSlowa_v4 {

    public static void main(String[] args) {
        try(Scanner scanner = new Scanner(new File("pliki/pan_tadeusz.txt"))) {
            scanner.useDelimiter("[^\\p{L}\\d]+");
            
            // Strumień wszystkich słów jest dostępny jako "tokens()".
            // Gdybyśmy mieli listę Stringów i napisali lista.stream()
            // to właśnie dałoby to analogiczny efekt, jak scanner.tokens()
            // scanner.tokens().forEach(System.out::println);
                
            Map<String, Long> slownik = scanner.tokens()
                    .collect(Collectors.groupingBy(Function.identity(), Collectors.counting()));
            
            // zapisałem wynik grupowania do zmiennej, aby pokazać, żde wychodzi własnie taki słownik, jak wcześniej
            
            slownik.forEach((k, v) -> {
                System.out.println(k + " → " + v);
            });
            
        } catch(FileNotFoundException e) {
            e.printStackTrace();
        }        
    }

}
