package domowe.r4.pan_tadeusz;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Map;
import java.util.Scanner;
import java.util.function.Function;
import java.util.stream.Collectors;

public class PoliczWszystkieSlowa_v5 {

    public static void main(String[] args) {
        try(Scanner scanner = new Scanner(new File("pliki/pan_tadeusz.txt"))) {
            scanner.useDelimiter("[^\\p{L}\\d]+");
            
            // W tej wersji będzie tylko jeden "pipeline", w którym pośrednio pojawi się słownik,
            // ale od razu na nim wykonamy dalsze kroki.
            scanner.tokens()
                    .map(String::toLowerCase)
                    .collect(Collectors.groupingBy(Function.identity(), Collectors.counting()))
                    .entrySet()
                    .stream()
                    .sorted(Map.Entry.comparingByValue())
                    .forEachOrdered(entry -> {
                        System.out.println(entry.getKey() + " → " + entry.getValue());
            });
        } catch(FileNotFoundException e) {
            e.printStackTrace();
        }        
    }

}
