package p20_konto;

import java.time. LocalDate;
import java.time.Period;
import java.time.temporal.ChronoUnit;

public class Osoba {
	private String imie;
	private String nazwisko;
	private LocalDate dataUrodzenia;
	
	public Osoba(String imie, String nazwisko, LocalDate dataUrodzenia) {
		this.imie = imie;
		this.nazwisko = nazwisko;
		this.dataUrodzenia = dataUrodzenia;
	}
	
	public Osoba(String imie, String nazwisko, String dataUrodzenia) {
		this(imie, nazwisko, LocalDate.parse(dataUrodzenia));
	}
	
	public Osoba(String imie, String nazwisko, int wiek) {
		this(imie, nazwisko, LocalDate.now().minus(wiek, ChronoUnit.YEARS));
	}
	
	public String getImie() {
		return imie;
	}
	
	public String getNazwisko() {
		return nazwisko;
	}
	
	public LocalDate getDataUrodzenia() {
		return dataUrodzenia;
	}
	
	public int getWiek() {
		Period czasZycia = Period.between(dataUrodzenia, LocalDate.now()); // ile lat, miesięcy, dni
		return czasZycia.getYears(); // ile pełnych lat
	}
	
	public void setImie(String imie) {
		this.imie = imie;
	}
	
	public void setNazwisko(String nazwisko) {
		this.nazwisko = nazwisko;
	}
	
	@Override
	public String toString() {
		return imie + " " + nazwisko + ", ur. " + dataUrodzenia;
	}

}
