package p20_konto;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Test;

class KontoTest {

	@Test
	void testToString() {
		System.out.println("początek testu toString");
		Osoba ala = new Osoba("Ala", "Kowalska", "2000-01-01");
		Konto konto = new Konto(1, 1000, ala);
		assertEquals("Konto nr 1, saldo 1000, wł. Ala Kowalska, ur. 2000-01-01", konto.toString());
		System.out.println("koniec testu toString");
	}

	@Test
	void testWplata() {
		Osoba ala = new Osoba("Ala", "Kowalska", "2000-01-01");
		Konto konto = new Konto(1, 1000, ala);
		konto.wplata(200);
		assertEquals(1200, konto.getSaldo());
	}

	@Test
	void testWyplata() throws BrakSrodkow {
		Osoba ala = new Osoba("Ala", "Kowalska", "2000-01-01");
		Konto konto = new Konto(1, 1000, ala);
		konto.wyplata(300);
		assertEquals(700, konto.getSaldo());
	}

	@Test
	void testPrzelew() throws BrakSrodkow {
		Osoba ala = new Osoba("Ala", "Kowalska", "2000-01-01");
		Konto konto1 = new Konto(1, 1000, ala);
		Konto konto2 = new Konto(2, 2000, ala);
		konto1.przelew(400, konto2);
		assertEquals(600, konto1.getSaldo());
		assertEquals(2400, konto2.getSaldo());
	}

}
