package waluty;

import static org.junit.jupiter.api.Assertions.*;

import java.math.BigDecimal;

import org.junit.jupiter.api.Test;

class WalutaTest {
    // arrange - act - assert
    // having - when - then

    @Test
    void testTworzeniaObiektu() {
        BigDecimal kurs = new BigDecimal("4.0123");
        Waluta waluta = new Waluta("USD", "dolar", kurs);
        // assert "USD".equals(waluta.code());
        // JUnit oferuje własne asercje w postaci metod:
        assertEquals("USD", waluta.code());
        assertEquals("dolar", waluta.currency());
        assertEquals(kurs, waluta.mid());
    }

    @Test
    void testPrzeliczNaZlote() {
        // Ze względu na to, że pracujemy z BigDecimal, wcześniej przygotowuję wartości używane w teście i zapisuję do zmiennych
        BigDecimal kurs = new BigDecimal("4.0000");
        BigDecimal kwota = new BigDecimal("1000.00");
        BigDecimal oczekiwanyWynik = new BigDecimal("4000.00");
        
        Waluta waluta = new Waluta("USD", "dolar", kurs);
        BigDecimal wynik = waluta.przeliczNaZlote(kwota);
        assertEquals(oczekiwanyWynik, wynik);
    }

    @Test
    void testPrzeliczNaZloteZaokrlaglanie() {
        BigDecimal kurs = new BigDecimal("3.3333");
        BigDecimal kwota = new BigDecimal("20.00");
        BigDecimal oczekiwanyWynik = new BigDecimal("66.67");
        
        Waluta waluta = new Waluta("ABC", "cośtam", kurs);
        BigDecimal wynik = waluta.przeliczNaZlote(kwota);
        assertEquals(oczekiwanyWynik, wynik);
    }
    
    @Test
    void testPrzeliczNaWalute() {
        BigDecimal kurs = new BigDecimal("4.0000");
        BigDecimal kwota = new BigDecimal("4000.00");
        BigDecimal oczekiwanyWynik = new BigDecimal("1000.00");
        
        Waluta waluta = new Waluta("USD", "dolar", kurs);
        BigDecimal wynik = waluta.przeliczNaWalute(kwota);
        assertEquals(oczekiwanyWynik, wynik);
    }
    
    @Test
    void testPrzeliczNaWaluteZaokrlaglanie() {
        BigDecimal kurs = new BigDecimal("3.0000");
        BigDecimal kwota = new BigDecimal("2000.00");
        BigDecimal oczekiwanyWynik = new BigDecimal("666.67");
        
        Waluta waluta = new Waluta("XYZ", "dolar iksowy", kurs);
        BigDecimal wynik = waluta.przeliczNaWalute(kwota);
        assertEquals(oczekiwanyWynik, wynik);
    }
}
